module Net
  class HTTPGenericRequest
    SEND_BUFFER_SIZE = 10240
    remove_method :send_request_with_body
    # FIXME: this interface will be changed in new implementation
    # of net/http.  must follow.
    def send_request_with_body( sock, ver, path, body )
      unless @header.has_key?('content-length')
        if body.respond_to?(:length) && body.length
          @header['content-length'] = body.length.to_s
        elsif body.respond_to?(:size) && body.size
          @header['content-length'] = body.size.to_s
        else
          $stderr.puts 'net/http: warning: cannot get Content-Length; request may be failed.'
        end
      end
      @header.delete 'transfer-encoding'
      
      unless @header['content-type']
        $stderr.puts 'net/http: warning: Content-Type did not set; using application/x-www-form-urlencoded' if $VERBOSE
        @header['content-type'] = 'application/x-www-form-urlencoded'
      end
      request sock, ver, path
      if body.kind_of?(IO)
        while ( ! body.eof? )
          sock.write body.read(SEND_BUFFER_SIZE)
        end
      else
        sock.write body
      end
    end
  end # HTTPGenericRequest
end # Net

