#
# VFS for ruby - open anything with URI
# 
#   Copyright: Tatsuki Sugiura <sugi@nemui.org>
#   License: Ruby's original or GPL2
#   $LastChangedDate: 2003-11-20 09:16:53 +0900 (Thu, 20 Nov 2003) $
#   $LastChangedBy: sugi $
#

require 'vfs/dir'
require 'vfs/scheme/zip/common'

module VFS;  module SchemeHandler;  module ZIP;
  class Dir < VFS::Dir
    include VFS::SchemeHandler::ZIP::Common

    def entries
      return @entries unless @entries == nil
      @entries = []
      ziparc_open { |zf|
        zf.dir.foreach(zipcont) { |e|
          @entries << e
        }
      }
      @entries
    end

    def delete
      ziparc_open { |zf|
        zf.dir.delete(zipcont)
      }
      self
    end
    alias :rmdir  :delete
    alias :unlink :delete
    
    def mkdir(perm=0)
      ziparc_open { |zf|
        zf.mkdir(zipcont,perm)
      }
      self
    end

  end
end; end; end
